{% extends 'base.html' %}
{% load static %}

{% block content %}
    <div class="messages container">
        <div class="row mt-2 mb-3 justify-content-center">
            {% if messages %}
                {% for message in messages %}
                    <div class="col-7 alert {{ message.tags }} alert-dismissible show mb-0" role="alert">
                        <h5 class="m-0 ps-3 text-center">{{ message }}</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close">
                        </button>
                    </div>
                {% endfor %}
            {% endif %}
        </div>
    </div>

    <div class="container">
        <div class="row">
            <div class="col-9 bg-white rounded">

                <ul id="animeDetailTabs" class="nav nav-tabs mt-2">
                    <li class="nav-item">
                        <a class="nav-link {% if not reviews_tab %}active{% endif %}" aria-current="page"
                           href="{% url 'v_anime_detail' %}?watch={{ single_anime.id }}">Video</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link {% if reviews_tab %}active{% endif %}" aria-current="page"
                           href="{% url 'v_anime_reviews' %}?watch={{ single_anime.id }}">Reviews</a>
                    </li>
                </ul>

                {% if not reviews_tab %}
                <div class="accordion accordion-flush" id="accordionSeries">
                    {% for serie, eps in series_eps %}
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse"
                                        data-bs-target="#collapse_{{ serie.id }}" aria-expanded="false"
                                        aria-controls="collapse_{{ serie.id }}">
                                    {{ serie.nome }}
                                </button>
                            </h2>
                            <div id="collapse_{{ serie.id }}" class="accordion-collapse collapse"
                                 aria-labelledby="headingOne"
                                 data-bs-parent="#accordionSeries">
                                <div class="accordion-body">
                                    <div class="row row-cols-1 row-cols-sm-2 row-cols-md-4 g-3">
                                        {% for ep in eps %}
                                            <div class="col">
                                                <div class="card shadow-sm">
                                                    <form action="{% url 'v_anime_detail' %}?watch={{ single_anime.id }}" method="post">
                                                        {% csrf_token %}
                                                        <button class="episodeButton"
                                                                type="submit" name="watchingAnime"
                                                                value="{{ single_anime.id }}">
                                                            <img class="img-fluid white-img-filter"
                                                                 src="{% static 'icons/play_arrow_black.svg' %}"
                                                                 alt="play_arrow_black-icon"
                                                                 width="80">
                                                        </button>
                                                    </form>
                                                    <div class="card-body">
                                                        <h6 class="card-text text-center">{{ ep.titolo }}</h6>
                                                    </div>
                                                </div>
                                            </div>
                                        {% endfor %}
                                    </div>
                                </div>
                            </div>
                        </div>
                    {% endfor %}
                </div>
                {% else %}
                    <div class="p-3 border-bottom">
                        <h5><strong>Average rating</strong></h5>
                        <div class="row">
                            <div class="col">
                                {% include 'animeflix_app/pages/../animeEvaluation/animeRating.html' %}

                                <p class="fs-6 fw-bold m-0">{{ single_anime.avg_rating|floatformat:"1" }} out of {{ stars_list|length }}</p>
                                <p class="fs-6 m-0 light-grey-text-color">{{ evaluations|length }} votes</p>
                            </div>

                            {% if user.is_authenticated %}
                                {% if not single_anime.premium or single_anime.premium and user_premium %}
                                    <div class="col-auto">
                                        <a id="write-review-btn" href="{% url 'v_anime_new_review' %}?watch={{ single_anime.id }}"
                                           class="btn btn-light border border-1 px-4">
                                            Write a review
                                        </a>
                                    </div>
                                {% endif %}
                            {% endif %}
                        </div>
                    </div>

                    <div class="p-3 reviews">
                        <h5><strong>User reviews</strong></h5>
                        {% if evaluations %}
                            {% for eval in evaluations %}
                                <div class="row border border-1 my-2 py-2 px-3 {% if user.is_authenticated and user == eval.author.account %}light-blue-background{% endif %}">
                                    <div class="d-flex p-0">
                                        <div class="review-stat">
                                            {% for star in stars_list %}
                                                {% if forloop.counter <= eval.vote %}
                                                    <i class="star rating-color"></i>
                                                {% else %}
                                                    <i class="star"></i>
                                                {% endif %}
                                            {% endfor %}
                                        </div>
                                        <h6 class="ps-3 align-self-{% if user.is_authenticated and user == eval.author.account %}center{% else %}end{% endif %}">
                                            <strong>{{ eval.title }}</strong>
                                        </h6>

                                        {% if user.is_authenticated and user == eval.author.account %}
                                            <div class="buttons ms-auto">
                                                {% if not single_anime.premium or single_anime.premium and user_premium %}
                                                    <a href="{% url 'v_anime_edit_review' eval.pk %}?watch={{ single_anime.pk }}" class="btn btn-sm align-baseline px-1">
                                                        <img class="dark-blue-img-filter" src="{% static 'icons/edit.svg' %}" alt="edit-icon">
                                                    </a>
                                                {% endif %}

                                                <button type="button" data-bs-toggle="modal" data-bs-target="#del-review-{{ eval.pk }}-modal" class="btn btn-sm px-1">
                                                    <img class="dark-blue-img-filter" src="{% static 'icons/close.svg' %}" width="30" alt="close-icon">
                                                </button>
                                                {% include 'animeflix_app/animeEvaluation/deleteReviewModal.html' %}
                                            </div>
                                        {% endif %}
                                    </div>
                                    <p class="p-0 light-grey-text-color">From
                                        <span class="primary-text-color">{{ eval.author }}</span> posted {{ eval.mod_date_str }}</p>
                                    {{ eval.review|safe }}
                                </div>
                            {% endfor %}
                        {% else %}
                            <p class="m-0">There are no reviews for this anime. Be the first!</p>
                        {% endif %}
                    </div>

                    <!-- Review form -->
                    {% block new-review %}{% endblock %}
                {% endif %}
            </div>

            <div class="col-3">
                <div class="d-flex flex-column align-items-stretch flex-shrink-0 bg-white rounded">
                    <img class="img-fluid" src="{{ single_anime.copertina }}"
                         alt="{{ single_anime.copertina }}">
                    <div class="list-group list-group-flush border-bottom rounded">
                        <div class="position-relative">
                            {% if single_anime.premium %}
                                <img class="img-fluid position-absolute translate-middle rounded-circle white-img-filter bg-primary p-1"
                                     src="{% static 'icons/workspace_premium_black.svg' %}" alt="premium_icon"
                                     style="left: 90%; z-index: 10;">
                            {% endif %}
                        </div>
                        <div class="list-group-item py-3 lh-tight">
                            <div class="d-flex w-100 align-items-center justify-content-between">
                                <strong>{{ single_anime.titolo }} </strong>
                                <small class="text-muted">
                                    {{ single_anime.tot_episodi }} Episode{{ single_anime.tot_episodi|pluralize }}
                                </small>
                            </div>

                            <div id="add_anime_form" class="d-flex justify-content-center">
                                <form action="{% url 'v_anime_detail' %}?watch={{ single_anime.id }}" method="post">
                                    {% csrf_token %}
                                    <button type="submit" name="addanime" value="{{ single_anime.id }}" class="btn">
                                        <small class="text-muted">Add to favourites</small>
                                        <img class="img-fluid primary-img-filter" src="{% static 'icons/bookmark_add_outline.svg' %}"
                                             width="25" alt="anime-bookmark-icon">
                                    </button>
                                </form>
                            </div>
                            <div class="col-10 mb-1 small rounded">{{ single_anime.trama }}</div>

                            <div class="border-top border-bottom mt-2 py-2">
                                <div class="d-flex">
                                    <h6 class="my-auto pe-2"><strong>Average rating:</strong></h6>
                                    {% include 'animeflix_app/pages/../animeEvaluation/animeRating.html' %}
                                </div>
                                <a href="{% url 'v_anime_reviews' %}?watch={{ single_anime.pk }}">Read reviews</a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <style>
        img[alt="anime-bookmark-icon"]:hover {
            content: url({% static 'icons/bookmark_add_black.svg' %});
        }
    </style>

    <script>
        $('#write-review-btn').click(function () {
            {% if not user.is_authenticated %}
                alert('You must be logged in to do this.');
                $(this).removeAttr("href");
            {% else %}
                let own_review = $('.reviews .light-blue-background')
                if (own_review.length !== 0) {
                    $(this).removeAttr("href");
                    own_review.attr("tabindex",-1).focus();
                }
            {% endif %}
        });

        // default for accordion
        {% if not reviews_tab %}
            const accordionButtons = document.getElementsByClassName('accordion-button');
            const accordionItems = document.getElementsByClassName('accordion-collapse');
            accordionButtons[0].classList.remove('collapsed');
            accordionItems[0].classList.add('show');
        {% endif %}
    </script>

{% endblock %}